<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatMap ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatMap
 * @subpackage Arrays
 */
class ArrayOfSeatMap extends AbstractStructArrayBase
{
    /**
     * The SeatMap
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SeatMap[]
     */
    public $SeatMap;
    /**
     * Constructor method for ArrayOfSeatMap
     * @uses ArrayOfSeatMap::setSeatMap()
     * @param \App|C\StructType\SeatMap[] $seatMap
     */
    public function __construct(array $seatMap = array())
    {
        $this
            ->setSeatMap($seatMap);
    }
    /**
     * Get SeatMap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SeatMap[]|null
     */
    public function getSeatMap()
    {
        return isset($this->SeatMap) ? $this->SeatMap : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatMap method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatMap method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatMapForArrayConstraintsFromSetSeatMap(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatMapSeatMapItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatMapSeatMapItem instanceof \App|C\StructType\SeatMap) {
                $invalidValues[] = is_object($arrayOfSeatMapSeatMapItem) ? get_class($arrayOfSeatMapSeatMapItem) : sprintf('%s(%s)', gettype($arrayOfSeatMapSeatMapItem), var_export($arrayOfSeatMapSeatMapItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatMap property can only contain items of type \App|C\StructType\SeatMap, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatMap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatMap[] $seatMap
     * @return \App|C\ArrayType\ArrayOfSeatMap
     */
    public function setSeatMap(array $seatMap = array())
    {
        // validation for constraint: array
        if ('' !== ($seatMapArrayErrorMessage = self::validateSeatMapForArrayConstraintsFromSetSeatMap($seatMap))) {
            throw new \InvalidArgumentException($seatMapArrayErrorMessage, __LINE__);
        }
        if (is_null($seatMap) || (is_array($seatMap) && empty($seatMap))) {
            unset($this->SeatMap);
        } else {
            $this->SeatMap = $seatMap;
        }
        return $this;
    }
    /**
     * Add item to SeatMap value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatMap $item
     * @return \App|C\ArrayType\ArrayOfSeatMap
     */
    public function addToSeatMap(\App|C\StructType\SeatMap $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SeatMap) {
            throw new \InvalidArgumentException(sprintf('The SeatMap property can only contain items of type \App|C\StructType\SeatMap, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatMap[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SeatMap|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SeatMap|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SeatMap|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SeatMap|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SeatMap|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatMap
     */
    public function getAttributeName()
    {
        return 'SeatMap';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfSeatMap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
