<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketTax ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTicketTax
 * @subpackage Arrays
 */
class ArrayOfTicketTax extends AbstractStructArrayBase
{
    /**
     * The TicketTax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\TicketTax[]
     */
    public $TicketTax;
    /**
     * Constructor method for ArrayOfTicketTax
     * @uses ArrayOfTicketTax::setTicketTax()
     * @param \App|C\StructType\TicketTax[] $ticketTax
     */
    public function __construct(array $ticketTax = array())
    {
        $this
            ->setTicketTax($ticketTax);
    }
    /**
     * Get TicketTax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\TicketTax[]|null
     */
    public function getTicketTax()
    {
        return isset($this->TicketTax) ? $this->TicketTax : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTicketTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTicketTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTicketTaxForArrayConstraintsFromSetTicketTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTicketTaxTicketTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketTaxTicketTaxItem instanceof \App|C\StructType\TicketTax) {
                $invalidValues[] = is_object($arrayOfTicketTaxTicketTaxItem) ? get_class($arrayOfTicketTaxTicketTaxItem) : sprintf('%s(%s)', gettype($arrayOfTicketTaxTicketTaxItem), var_export($arrayOfTicketTaxTicketTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TicketTax property can only contain items of type \App|C\StructType\TicketTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TicketTax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\TicketTax[] $ticketTax
     * @return \App|C\ArrayType\ArrayOfTicketTax
     */
    public function setTicketTax(array $ticketTax = array())
    {
        // validation for constraint: array
        if ('' !== ($ticketTaxArrayErrorMessage = self::validateTicketTaxForArrayConstraintsFromSetTicketTax($ticketTax))) {
            throw new \InvalidArgumentException($ticketTaxArrayErrorMessage, __LINE__);
        }
        if (is_null($ticketTax) || (is_array($ticketTax) && empty($ticketTax))) {
            unset($this->TicketTax);
        } else {
            $this->TicketTax = $ticketTax;
        }
        return $this;
    }
    /**
     * Add item to TicketTax value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\TicketTax $item
     * @return \App|C\ArrayType\ArrayOfTicketTax
     */
    public function addToTicketTax(\App|C\StructType\TicketTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\TicketTax) {
            throw new \InvalidArgumentException(sprintf('The TicketTax property can only contain items of type \App|C\StructType\TicketTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TicketTax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\TicketTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\TicketTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\TicketTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\TicketTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\TicketTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TicketTax
     */
    public function getAttributeName()
    {
        return 'TicketTax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfTicketTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
