<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfValueCodeProperty ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfValueCodeProperty
 * @subpackage Arrays
 */
class ArrayOfValueCodeProperty extends AbstractStructArrayBase
{
    /**
     * The ValueCodeProperty
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ValueCodeProperty[]
     */
    public $ValueCodeProperty;
    /**
     * Constructor method for ArrayOfValueCodeProperty
     * @uses ArrayOfValueCodeProperty::setValueCodeProperty()
     * @param \App|C\StructType\ValueCodeProperty[] $valueCodeProperty
     */
    public function __construct(array $valueCodeProperty = array())
    {
        $this
            ->setValueCodeProperty($valueCodeProperty);
    }
    /**
     * Get ValueCodeProperty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ValueCodeProperty[]|null
     */
    public function getValueCodeProperty()
    {
        return isset($this->ValueCodeProperty) ? $this->ValueCodeProperty : null;
    }
    /**
     * This method is responsible for validating the values passed to the setValueCodeProperty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setValueCodeProperty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateValueCodePropertyForArrayConstraintsFromSetValueCodeProperty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfValueCodePropertyValueCodePropertyItem) {
            // validation for constraint: itemType
            if (!$arrayOfValueCodePropertyValueCodePropertyItem instanceof \App|C\StructType\ValueCodeProperty) {
                $invalidValues[] = is_object($arrayOfValueCodePropertyValueCodePropertyItem) ? get_class($arrayOfValueCodePropertyValueCodePropertyItem) : sprintf('%s(%s)', gettype($arrayOfValueCodePropertyValueCodePropertyItem), var_export($arrayOfValueCodePropertyValueCodePropertyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ValueCodeProperty property can only contain items of type \App|C\StructType\ValueCodeProperty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ValueCodeProperty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ValueCodeProperty[] $valueCodeProperty
     * @return \App|C\ArrayType\ArrayOfValueCodeProperty
     */
    public function setValueCodeProperty(array $valueCodeProperty = array())
    {
        // validation for constraint: array
        if ('' !== ($valueCodePropertyArrayErrorMessage = self::validateValueCodePropertyForArrayConstraintsFromSetValueCodeProperty($valueCodeProperty))) {
            throw new \InvalidArgumentException($valueCodePropertyArrayErrorMessage, __LINE__);
        }
        if (is_null($valueCodeProperty) || (is_array($valueCodeProperty) && empty($valueCodeProperty))) {
            unset($this->ValueCodeProperty);
        } else {
            $this->ValueCodeProperty = $valueCodeProperty;
        }
        return $this;
    }
    /**
     * Add item to ValueCodeProperty value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ValueCodeProperty $item
     * @return \App|C\ArrayType\ArrayOfValueCodeProperty
     */
    public function addToValueCodeProperty(\App|C\StructType\ValueCodeProperty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ValueCodeProperty) {
            throw new \InvalidArgumentException(sprintf('The ValueCodeProperty property can only contain items of type \App|C\StructType\ValueCodeProperty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ValueCodeProperty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ValueCodeProperty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ValueCodeProperty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ValueCodeProperty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ValueCodeProperty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ValueCodeProperty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ValueCodeProperty
     */
    public function getAttributeName()
    {
        return 'ValueCodeProperty';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfValueCodeProperty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
