<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfoBooking StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfoBooking
 * @subpackage Structs
 */
class FareInfoBooking extends FareInfoEMD
{
    /**
     * The SaleCurrencyAmountToPay
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AmountBase
     */
    public $SaleCurrencyAmountToPay;
    /**
     * The SaleCurrencyAmountToPayInAccount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $SaleCurrencyAmountToPayInAccount;
    /**
     * Constructor method for FareInfoBooking
     * @uses FareInfoBooking::setSaleCurrencyAmountToPay()
     * @uses FareInfoBooking::setSaleCurrencyAmountToPayInAccount()
     * @param \App|C\StructType\AmountBase $saleCurrencyAmountToPay
     * @param float $saleCurrencyAmountToPayInAccount
     */
    public function __construct(\App|C\StructType\AmountBase $saleCurrencyAmountToPay = null, $saleCurrencyAmountToPayInAccount = null)
    {
        $this
            ->setSaleCurrencyAmountToPay($saleCurrencyAmountToPay)
            ->setSaleCurrencyAmountToPayInAccount($saleCurrencyAmountToPayInAccount);
    }
    /**
     * Get SaleCurrencyAmountToPay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AmountBase|null
     */
    public function getSaleCurrencyAmountToPay()
    {
        return isset($this->SaleCurrencyAmountToPay) ? $this->SaleCurrencyAmountToPay : null;
    }
    /**
     * Set SaleCurrencyAmountToPay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AmountBase $saleCurrencyAmountToPay
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyAmountToPay(\App|C\StructType\AmountBase $saleCurrencyAmountToPay = null)
    {
        if (is_null($saleCurrencyAmountToPay) || (is_array($saleCurrencyAmountToPay) && empty($saleCurrencyAmountToPay))) {
            unset($this->SaleCurrencyAmountToPay);
        } else {
            $this->SaleCurrencyAmountToPay = $saleCurrencyAmountToPay;
        }
        return $this;
    }
    /**
     * Get SaleCurrencyAmountToPayInAccount value
     * @return float|null
     */
    public function getSaleCurrencyAmountToPayInAccount()
    {
        return $this->SaleCurrencyAmountToPayInAccount;
    }
    /**
     * Set SaleCurrencyAmountToPayInAccount value
     * @param float $saleCurrencyAmountToPayInAccount
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyAmountToPayInAccount($saleCurrencyAmountToPayInAccount = null)
    {
        // validation for constraint: float
        if (!is_null($saleCurrencyAmountToPayInAccount) && !(is_float($saleCurrencyAmountToPayInAccount) || is_numeric($saleCurrencyAmountToPayInAccount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($saleCurrencyAmountToPayInAccount, true), gettype($saleCurrencyAmountToPayInAccount)), __LINE__);
        }
        $this->SaleCurrencyAmountToPayInAccount = $saleCurrencyAmountToPayInAccount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareInfoBooking
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
